#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Red
#property indicator_color2 DodgerBlue
#property indicator_color3 White
//----
extern int TimeFrame=5;
extern int TimeFrame2=30;
extern int TimeFrame3=60;


//----
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE);
//---- name for DataWindow and indicator subwindow label   
   switch(TimeFrame)
     {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
     }
   IndicatorShortName("MTF_III ("+TimeFrameStr+")");
  }
//----
   return(0);
//+------------------------------------------------------------------+
//| MTF RSI                                                          |
//+------------------------------------------------------------------+
int start()
{
   int i,counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=Bars-counted_bars;
             limit=MathMax(limit,3*TimeFrame /Period());
             limit=MathMax(limit,3*TimeFrame2/Period());
             limit=MathMax(limit,3*TimeFrame3/Period());
             limit=MathMin(limit,Bars-1);

   for(i=limit;i>=0;i--)
   {
      ExtMapBuffer1[i]=((iHigh(NULL, TimeFrame, iHighest(NULL, TimeFrame, MODE_CLOSE, 4,iBarShift(NULL,TimeFrame ,Time[i]))) - iClose(0,0,iBarShift(NULL,TimeFrame ,Time[i])))) ;
      ExtMapBuffer2[i]=((iHigh(NULL, TimeFrame2, iHighest(NULL, TimeFrame2, MODE_CLOSE, 4,iBarShift(NULL,TimeFrame2 ,Time[i]))) - iClose(0,0,iBarShift(NULL,TimeFrame2 ,Time[i])))) ; 
      ExtMapBuffer3[i]=((iHigh(NULL, TimeFrame3, iHighest(NULL, TimeFrame3, MODE_CLOSE, 4,iBarShift(NULL,TimeFrame3 ,Time[i]))) - iClose(0,0,iBarShift(NULL,TimeFrame3 ,Time[i])))) ;
   }
   return(0);
}